Non puoi selezionare più di 25 argomenti Gli argomenti devono iniziare con una lettera o un numero, possono includere trattini ('-') e possono essere lunghi fino a 35 caratteri.
 
 
 
 
 
 

1314 righe
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __lf=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. if null type figlet && null type lolcat
  163. then
  164. hostname -s | figlet | lolcat
  165. fi
  166. uname -a
  167. $iswindows && alias tty="echo cmd.exe"
  168. echo TERM $TERM with $(tput colors) colors using $(tty)
  169. echo umask: `umask -S`
  170. echo
  171. __safe_run w yuk
  172. # if null type tmux
  173. # then
  174. # echo
  175. # echo tmux sessions:
  176. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  177. # echo
  178. # fi
  179. # if test -n "$TMUX"
  180. # then
  181. # tmux display -p \
  182. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  183. # 2>/dev/null
  184. # echo
  185. # fi
  186. if test -n "$__MY_DTACH"
  187. then
  188. echo
  189. echo DSession: Current Session: "`basename "$__MY_DTACH"`"
  190. echo DSession: Press C-^ to Exit.
  191. true
  192. fi
  193. i(){
  194. w
  195. ss -lnp
  196. ps aufx
  197. df -h
  198. top -b -d 1 -n 1
  199. top -b -d 1 -n 1 -a
  200. dstat -taf 1 10
  201. }
  202. ###################################
  203. # some aliases and functions
  204. # __func_name: never used interactively
  205. # _func_name: usually not used interactively
  206. __safe_alias(){
  207. # __safe_alias <name>=<command>
  208. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  209. test -n "$_bin" && \
  210. null type $_bin && \
  211. alias "$1"
  212. }
  213. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  214. # color prefs
  215. if $gnu_coreutils
  216. then
  217. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  218. # gnu coreutils LS_COLORS is used
  219. null type dircolors && eval `dircolors`
  220. _coloroption=" --color=auto"
  221. else
  222. # export LSCOLORS=gxfxcxdxbxegedabagacad
  223. export LSCOLORS=DxGxcxdxCxegedabagacad
  224. export CLICOLOR=1
  225. fi
  226. alias ls="ls -hCF${_coloroption}${_timeoption}"
  227. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  228. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  229. _timeformat_num="%Y%m%d%H%M%S"
  230. alias datenum="date +$_timeformat_num"
  231. alias less="less -F"
  232. __safe_alias em="emacs -nw"
  233. test -n "$_VI_ALT" && alias vi=$_VI_ALT
  234. alias pstree="LANG=C pstree"
  235. alias cp="cp -v"
  236. alias mv="mv -v"
  237. alias rm="rm -v"
  238. alias mkdir="mkdir -v"
  239. $gnu_coreutils && alias rmdir="rmdir -v"
  240. alias psaux="ps auxww"
  241. alias modest="ionice -c 2 -n 7 nice -n 19"
  242. alias e=exec
  243. __safe_alias e3=e3em
  244. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  245. alias po=popd
  246. alias pu=pushd
  247. __safe_alias sudo="sudo " # use aliases through sudo
  248. __safe_alias sudoe="sudoedit"
  249. __safe_alias make="nice make"
  250. __safe_alias brew="nice brew"
  251. __safe_alias gcc="nice gcc"
  252. __safe_alias go="nice go"
  253. __safe_alias git="nice git"
  254. __safe_alias javac="nice javac -J-Duser.language=en"
  255. alias rand="echo \$RANDOM"
  256. alias pycalc="python -i -c 'from math import *' "
  257. __safe_alias py3=python3
  258. __safe_alias py2=python2
  259. __safe_alias ipy=ipython
  260. __safe_alias ipy3=ipython3
  261. __safe_alias ipy2=ipython2
  262. __safe_alias rl=rlwrap
  263. __safe_alias igosh=gosh-rl
  264. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  265. # SHELL is set to be /bin/zsh
  266. if $inbash
  267. then
  268. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  269. elif $inzsh
  270. then
  271. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  272. else
  273. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  274. fi
  275. # alias mytime="date +%Y%m%d-%H%M%S"
  276. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  277. # some extra utilities
  278. __safe_alias mpg123="mpg123 -C -v --title"
  279. #export PLAYER="mpg123 -C -v --title"
  280. __safe_alias screen="screen -e^z^z"
  281. #alias zcd="cd \`zenity --file-selection --directory\`"
  282. __safe_alias gtags="gtags --verbose"
  283. __safe_alias htags="htags --xhtml --symbol --line-number \
  284. --frame --alphabet --verbose"
  285. __safe_alias au=aunpack
  286. # __safe_alias lv="lv|less"
  287. __safe_alias rs="rsync --progress --itemize-changes --compress"
  288. __safe_alias vagr=vagrant
  289. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  290. if $iscygwin
  291. then
  292. __my_wget_options=" --no-check-certificate"
  293. __safe_alias wget="wget $__my_wget_options"
  294. fi
  295. if $isdarwin
  296. then
  297. alias updatedb="LC_ALL=C updatedb"
  298. # do not use locate installed by macports
  299. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  300. fi
  301. # somehow not work
  302. # typeset -ga chpwd_functions
  303. # chpwd_functions+=pwd
  304. # chpwd(){
  305. # pwd
  306. # }
  307. cd(){
  308. builtin cd "$@" && pwd
  309. }
  310. root(){
  311. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  312. then
  313. cd "`git rev-parse --show-toplevel`"
  314. else
  315. cd /
  316. fi
  317. }
  318. __find_latest_vimdir(){
  319. vimdir=/usr/share/vim
  320. if test -d "$vimdir"
  321. then
  322. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  323. else
  324. echo ""
  325. fi
  326. }
  327. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  328. do
  329. test -n "$f" || continue
  330. f="$f/macros/less.sh"
  331. test -f $f && alias vl=$f && break
  332. done
  333. __safe_alias pa="pacman --color=always"
  334. __safe_alias pa="pacmatic --color=always"
  335. __safe_alias pa="pacapt"
  336. __safe_alias yt=yaourt
  337. # variable for yaourt
  338. null type pacmatic && export PACMAN="pacmatic"
  339. __safe_alias cower="cower --color=auto"
  340. __my_pacman_update_mirrorlist_with_reflector(){
  341. f=/etc/pacman.d/mirrorlist
  342. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  343. if test -z "$cmd"
  344. then
  345. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  346. fi
  347. echo ">>> $cmd ..." 1>&2
  348. sudo sh -c "$cmd" && cat $f
  349. }
  350. null type reflector && test -d /etc/pacman.d && \
  351. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  352. null type apt-get && {
  353. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  354. apt-get update --yes && apt-get upgrade --yes'"
  355. alias aptin="apt-get install"
  356. alias aptsearch="apt-cache search"
  357. alias aptshow="apt-cache show"
  358. }
  359. null type port && {
  360. alias port="port -v"
  361. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  362. port -v upgrade outdated'"
  363. }
  364. if $iscygwin
  365. then
  366. null type windate || \
  367. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  368. # alias cygsu="cygstart /cygwinsetup.exe"
  369. fi
  370. mkpatch(){
  371. if test $# -eq 0
  372. then
  373. echo "usage: mkpatch <olddir> <newdir>"
  374. elif ! test -d "$1"
  375. then
  376. echo "mkpatch: $1 is not a directory"
  377. elif ! test -d "$2"
  378. then
  379. echo "mkpatch: $2 is not a directory"
  380. else
  381. diff -Naur "$1" "$2"
  382. fi
  383. }
  384. __sdcv_less(){
  385. command sdcv -n "$@" | less --quit-if-one-screen
  386. }
  387. command -v sdcv >/dev/null && alias dict=__sdcv_less
  388. g(){
  389. if test $# -eq 0 && null type git-info
  390. then
  391. git info
  392. else
  393. git "$@"
  394. fi
  395. }
  396. $isdarwin && . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.bash
  397. if null type _git && $inbash
  398. then
  399. # enable programmable completion for g
  400. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  401. || complete -o default -o nospace -F _git g
  402. fi
  403. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  404. __safe_alias m=gitmemo
  405. #alias setup.py3="sudo python3 setup.py install --record files.txt"
  406. randomstr(){
  407. len=$1
  408. test -z "$len" && len=8
  409. uuidgen | tr -d - | cut -c 1-len
  410. }
  411. datestr(){
  412. # datestr YYYYMMDDhhmmss
  413. if test -z "$1" || test "$1" = "-h"
  414. then
  415. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  416. return 1
  417. fi
  418. # actual format for date command
  419. dfmt="`echo "$1" | \
  420. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  421. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  422. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  423. date +"$dfmt"
  424. }
  425. # ssh(){
  426. # # __my_terminal_title ssh
  427. # command ssh "$@"
  428. # }
  429. __ssh_with_cd(){
  430. # __ssh_with_cd <host> <directory> [<arg> ...]
  431. if test -z "$2"
  432. then
  433. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  434. return 1
  435. fi
  436. host="$1"
  437. shift
  438. dir="$1"
  439. shift
  440. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  441. }
  442. memo(){
  443. if test -z "$1"
  444. then
  445. _memo="memo.txt"
  446. else
  447. _memo="$1/memo.txt"
  448. fi
  449. $EDITOR "$_memo"
  450. if test -z "`cat "$_memo"`"
  451. then
  452. echo "$_memo is empty. Removing."
  453. rm "$_memo"
  454. fi
  455. }
  456. now(){
  457. ___tformat="%Y/%m/%d %H:%M:%S %z"
  458. cal
  459. REPLY=
  460. printf "\\r`date "+${___tformat}"`"
  461. read -t 1
  462. while test $? -ne 0
  463. do
  464. printf "\\r`date "+${___tformat}"`"
  465. read -t 1
  466. done
  467. }
  468. s(){
  469. if git rev-parse --git-dir >/dev/null 2>&1
  470. then
  471. echo ">> git grep -n $@" 1>&2
  472. git grep -n "$@"
  473. elif which ag >/dev/null 2>&1
  474. then
  475. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  476. ag --pager="$PAGER" "$@"
  477. elif which ack >/dev/null 2>&1
  478. then
  479. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  480. ack --pager="$PAGER" "$@"
  481. else
  482. echo \
  483. ">> find . " \
  484. "-path '*/.git' -prune -o" \
  485. "-path '*/.svn' -prune -o" \
  486. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  487. if test $# -eq 0
  488. then
  489. echo "No search word given." 1>&2
  490. return 1
  491. fi
  492. find . \
  493. -path '*/.git' -prune -o \
  494. -path '*/.svn' -prune -o \
  495. -type -f -exec grep -nH -e --color=always "$@" {} + \
  496. | $PAGER
  497. fi
  498. }
  499. MYMANPATH='/usr/lib/erlang/man'
  500. if $inbash || $inzsh
  501. then
  502. man(){
  503. env \
  504. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  505. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  506. LESS_TERMCAP_me=$(printf "\e[0m") \
  507. LESS_TERMCAP_se=$(printf "\e[0m") \
  508. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  509. LESS_TERMCAP_ue=$(printf "\e[0m") \
  510. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  511. MANPATH="`manpath`:$MYMANPATH" \
  512. man "$@"
  513. }
  514. fi
  515. netwait(){
  516. while ! ping -c 1 -t 1 example.com
  517. do
  518. true
  519. done
  520. echo network works.
  521. }
  522. __realpath(){
  523. if type realpath >/dev/null 2>&1
  524. then
  525. command realpath "$@"
  526. else
  527. while ! test -d $1
  528. do
  529. shift
  530. done
  531. (command cd "$d" && echo "$PWD")
  532. # local d="$OLDPWD"
  533. # command cd "$1"
  534. # echo "$PWD"
  535. # command cd "$d"
  536. fi
  537. }
  538. if $isdarwin
  539. then
  540. # I want to use env -u, but darwin env does not provide this option
  541. null type tmux && alias tmux='SHLVL= tmux'
  542. else
  543. null type tmux && alias tmux='env -u SHLVL tmux'
  544. fi
  545. tx(){
  546. tmux start-server
  547. if test -z "$1"
  548. then
  549. echo "usage: tx [<session_name>]"
  550. tmux list-sessions
  551. elif test -z "$TMUX"
  552. then
  553. # -A: attach if already exists
  554. # tmux new-session -A -c "$HOME" -s "$1"
  555. tmux new-session -A -s "$1"
  556. else
  557. # create new session if not exists yet
  558. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  559. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  560. tmux switch-client -t "$1"
  561. fi
  562. }
  563. __dsession(){
  564. # dt [-h] [<name>] [<command ...>]
  565. __dtach_dir="${TMP}/dtach"
  566. mkdir -p "${__dtach_dir}"
  567. if test -n "${__MY_DTACH}"
  568. then
  569. # if already in dtach session print current session
  570. soc_name="`basename "$__MY_DTACH"`"
  571. echo "Current session: ${soc_name}"
  572. fi
  573. if test -z "$1"
  574. then
  575. # if no arg given show list of sessions
  576. echo "Usage: ds [<session>]"
  577. echo "Sessions:"
  578. ls "${__dtach_dir}"
  579. return 0
  580. elif test "$1" = "-h"
  581. then
  582. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  583. return 1
  584. fi
  585. # set socket name
  586. soc_name="${__dtach_dir}/$1"
  587. shift
  588. if test -n "$__MY_DTACH"
  589. then
  590. echo "dtach session cannot be nested." 1>&2
  591. return 1
  592. elif test -S "$soc_name"
  593. then
  594. dtach -a "$soc_name" -e ^^
  595. elif test -e "$soc_name"
  596. then
  597. echo "dt: File named $soc_name already exists."
  598. return 1
  599. elif test -z "$1"
  600. then
  601. # if no command given invoke current shell
  602. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  603. # echo "dt: Socket named $soc_name not exists and no command specified."
  604. # return 1
  605. else
  606. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  607. fi
  608. }
  609. null type dtach && alias ds=__dsession
  610. scr(){
  611. test -n "$1" && pf="${1}-"
  612. ___tformat="%Y%m%d-%H%M%S%z"
  613. ___file="${HOME}/${pf}`date +${___tformat}`.script"
  614. __MY_SCRIPT=${___file} script ${___file} "$@"
  615. }
  616. dtscr(){
  617. # dtscr <command ...>
  618. if test -z "$1"
  619. then
  620. echo "dtscr: usage: dtscr <command ...>"
  621. return 1
  622. fi
  623. ___cmdstr="`echo $@ | tr ' ' +`"
  624. ___tformat="%Y%m%d-%H%M%S%z"
  625. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  626. ___scr_file="${HOME}/${___name}.script"
  627. ___dt_dir="${TMP}/dtscr"
  628. mkdir -p "$___dt_dir"
  629. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  630. # echo $_name
  631. # echo $_file
  632. }
  633. mcrypt_stream(){
  634. test $# -eq 2 || return 1
  635. case $1 in
  636. en)
  637. mcrypt --key $2 | base64 ;;
  638. de)
  639. base64 -d | mcrypt -d --key $2 ;;
  640. esac
  641. }
  642. gpg_stream(){
  643. test $# -eq 2 || return 1
  644. case $1 in
  645. en)
  646. gpg --passphrase $2 -c --batch |base64 ;;
  647. de)
  648. base64 -d|gpg --passphrase $2 -d --batch ;;
  649. esac
  650. }
  651. dgpg(){
  652. if test "$1" = help || test -z "$2"
  653. then
  654. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  655. return
  656. fi
  657. ___srcs="$2"
  658. ___dsts="$3"
  659. test -z "$___dsts" && ___dsts="${___srcs}.out"
  660. ___pw=
  661. echo -n "dgpg pw: "
  662. read -s ___pw
  663. echo ""
  664. test -z "$___pw" && return 1
  665. for f in *${___srcs}
  666. do
  667. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  668. echo -n "Processing $f to $___d..."
  669. if test -d "$f"
  670. then
  671. echo "`printf 'failed (%s is directory)' $f`"
  672. elif test -f "$___d"
  673. then
  674. echo "`printf 'failed (%s is already exists)' $___d`"
  675. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  676. then
  677. echo "done"
  678. else
  679. echo "failed"
  680. test -f "$___d" && rm "$___d"
  681. fi
  682. done
  683. }
  684. alias enst="gpg_stream en"
  685. alias dest="gpg_stream de"
  686. showinfo(){
  687. echo "Japanese letters are 表示可能"
  688. __safe_run diskinfo
  689. ! $isdarwin && test -n "${DISPLAY}" && {
  690. __safe_run xrandr | \grep --color=never ^Screen
  691. }
  692. $iswindows || __safe_run finger $USER
  693. LANG=C __safe_runc id
  694. __safe_run xset q
  695. }
  696. x(){
  697. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  698. #mkdir -p ~/.var/log
  699. # nohup startx >~/.var/log/xorg.log 2>&1 &
  700. # exit
  701. exec startx
  702. else
  703. echo "X cant be started! Another X is already running?" 1>&2
  704. fi
  705. }
  706. bak(){
  707. for file in "$@"
  708. do
  709. cp -v ${file} ${file}.bak
  710. done
  711. }
  712. di(){
  713. if null type git
  714. then
  715. git --git-dir= diff "$@"
  716. ___diffcmd="git --git-dir= diff"
  717. else
  718. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  719. then
  720. ___diffcmd=colordiff
  721. else
  722. ___diffcmd=diff
  723. fi
  724. ${___diffcmd} -u "$@" | ${PAGER}
  725. fi
  726. }
  727. tb(){
  728. __datenum=`date +%Y%m%d-%H%M%S`
  729. __tb="$HOME/.var/tb/$__datenum"
  730. mkdir -p "$__tb"
  731. mv "$@" "$__tb"
  732. }
  733. mkdd(){
  734. _d=`date +%Y%m%d-%H%M%S` && \
  735. mkdir -p "$_d"
  736. }
  737. mkcd(){
  738. if test -z "$1"
  739. then
  740. echo "mkcd: usage: mkcd <dir>"
  741. return 1
  742. elif test -d "$1"
  743. then
  744. echo "Dir \"$1\" already exists."
  745. else
  746. mkdir -p "$1"
  747. echo "Dir \"$1\" created."
  748. fi
  749. cd "$1"
  750. }
  751. mkcdd(){
  752. # make and change date directory
  753. _d=`date +%Y%m%d-%H%M%S` && \
  754. mkcd "$_d"
  755. }
  756. if test -n "$TMUX" && null type reattach-to-user-namespace
  757. then
  758. alias pbpaste="reattach-to-user-namespace pbpaste"
  759. alias pbcopy="reattach-to-user-namespace pbcopy"
  760. fi
  761. catclip(){
  762. if $iswindows
  763. then
  764. cat /dev/clipboard | tr -d \\r
  765. elif $isdarwin
  766. then
  767. pbpaste
  768. else
  769. xclip -o -selection "clipboard"
  770. fi
  771. }
  772. setclip(){
  773. if test $# -eq 0
  774. then
  775. exec 3<&0
  776. else
  777. exec 3<<__EOF__
  778. `cat "$@"`
  779. __EOF__
  780. fi
  781. if $iswindows
  782. then
  783. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  784. elif $isdarwin
  785. then
  786. pbcopy 0<&3
  787. else
  788. 0<&3 xclip -i -f -selection "primary" | \
  789. xclip -i -f -selection "clipboard"
  790. fi
  791. exec 3<&-
  792. }
  793. open_file(){
  794. if $iscygwin
  795. then
  796. cygstart "$@"
  797. elif $ismsys
  798. then
  799. cmd.exe //c start "" "$@"
  800. elif $isdarwin
  801. then
  802. touch "$@"
  803. open "$@"
  804. elif $islinux
  805. then
  806. touch "$@"
  807. if null type pcmanfm; then
  808. LC_MESSAGES= pcmanfm "$@"
  809. else
  810. LC_MESSAGES= xdg-open "$@" &
  811. fi
  812. else
  813. cat "$@"
  814. fi
  815. }
  816. o(){
  817. if test $# -eq 0
  818. then
  819. open_file .
  820. else
  821. for f in "$@"
  822. do
  823. open_file "$(realpath "$f")"
  824. done
  825. fi
  826. }
  827. convmv_sjis2utf8_test(){
  828. convmv -r -f sjis -t utf8 *
  829. }
  830. convmv_sjis2utf8_notest(){
  831. convmv -r -f sjis -t utf8 * --notest
  832. }
  833. #################################################
  834. ## pastebin services
  835. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  836. sprunge(){
  837. # http://sprunge.us
  838. if test -z "$1"
  839. then
  840. curl -F 'sprunge=<-' http://sprunge.us
  841. else
  842. curl http://sprunge.us/$1
  843. fi
  844. }
  845. dpaste(){
  846. # http://dpaste.de
  847. if test -z "$1"
  848. then
  849. curl -F 'content=<-' https://dpaste.de/api/
  850. echo
  851. else
  852. curl https://dpaste.de/$1/raw/
  853. fi
  854. }
  855. ######################################
  856. ## Prompt Settings
  857. __my_moc_state(){
  858. type mocp >/dev/null 2>&1 || return
  859. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  860. printf "$1" "`mocp -Q %title 2>/dev/null`"
  861. }
  862. __my_parse_svn_branch() {
  863. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  864. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  865. sed -ne 's#^Repository Root: ##p')
  866. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  867. awk '{print $1}'
  868. }
  869. __my_svn_ps1(){
  870. if svn status >/dev/null 2>&1
  871. then
  872. ___svn_branch=$(__my_parse_svn_branch)
  873. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  874. fi
  875. }
  876. __my_battery_status(){
  877. ___dir=/sys/class/power_supply/BAT0
  878. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  879. test -r $___dir/charge_now
  880. then
  881. ___st=$(cat $___dir/status)
  882. ___full=$(cat $___dir/charge_full)
  883. ___now=$(cat $___dir/charge_now)
  884. ___rate=$(expr "$___now" \* 100 / "$___full")
  885. printf "$1" "${___st}:${___rate}%"
  886. fi
  887. }
  888. alias bat='__my_battery_status %s\\n'
  889. __my_ps1_scale(){
  890. if null type stty && ! $ismsys
  891. then
  892. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  893. fi
  894. }
  895. __my_ps1_tmux(){
  896. null type tmux || return $last
  897. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  898. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  899. }
  900. __my_ps1_moc(){
  901. __my_moc_state "[MOC:%s]"
  902. }
  903. for f in /usr/share/git/git-prompt.sh \
  904. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  905. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  906. "`brew --prefix 2>/dev/null`"/etc/bash_completion.d/git-prompt.sh \
  907. /usr/share/git-core/contrib/completion/git-prompt.sh \
  908. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  909. /etc/bash_completion.d/git-prompt \
  910. /opt/local/share/git-core/git-prompt.sh \
  911. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  912. do
  913. test -r "$f" && ($inbash || $inzsh) && . "$f" && break
  914. done
  915. export GIT_PS1_SHOWDIRTYSTATE=t
  916. export GIT_PS1_SHOWUPSTREAM=t
  917. __my_ps1_git(){
  918. null type __git_ps1 || return $last
  919. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  920. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  921. }
  922. __printf_ipaddr(){
  923. # ipaddress <fmt>
  924. type ip >/dev/null 2>&1 || return 1
  925. ___ip=$(LANG=C ip addr show scope global | \
  926. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  927. test -n "$___ip" && printf "$1" $___ip
  928. }
  929. alias addr="__printf_ipaddr '%s'"
  930. __my_ps1_ipaddr(){
  931. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  932. }
  933. __my_ps1_bttry(){
  934. ___bst="$__homerun/batterystatus"
  935. if test -z "$DISPLAY" && ! $iswindows
  936. then
  937. test -f $___bst && ___bstr="$(cat $___bst)"
  938. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  939. echo "[Battery:${___bstr}]"
  940. __my_battery_status %s >$___bst &
  941. fi
  942. }
  943. __my_ps1_memo(){
  944. test -f memo.txt && echo "m:$(echo $(wc -c memo.txt) | cut -f 1 -d " ")"
  945. }
  946. __my_ps1_dirs(){
  947. dirs | wc -l
  948. }
  949. __my_ps1_jobs(){
  950. # __my_ps1_jobs [<num>]
  951. if test -n "$1"
  952. then
  953. jobs="$1"
  954. else
  955. jobs="`jobs | wc -l`"
  956. fi
  957. if test "$jobs" -gt 0
  958. then
  959. echo "JOBS:$jobs"
  960. fi
  961. }
  962. __my_ps1_dollar(){
  963. if test -z "$SHLVL"
  964. then
  965. printf "$1"
  966. else
  967. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  968. fi
  969. }
  970. __my_alert_fail(){
  971. test $laststatus -eq 0 || \
  972. echo "STATUS:${laststatus}"
  973. }
  974. # About ansi escape sequences
  975. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  976. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  977. if $inbash || $inzsh
  978. then
  979. if $inzsh
  980. then
  981. __attr_beg=$'%{\033['
  982. __attr_end='m%}'
  983. else
  984. __attr_beg='\[\033['
  985. __attr_end='m\]'
  986. fi
  987. __color_default="${__attr_beg}0${__attr_end}"
  988. __color_black="${__attr_beg}0;30${__attr_end}"
  989. __color_red="${__attr_beg}0;31${__attr_end}"
  990. __color_green="${__attr_beg}0;32${__attr_end}"
  991. __color_yellow="${__attr_beg}0;33${__attr_end}"
  992. __color_blue="${__attr_beg}0;34${__attr_end}"
  993. __color_magenta="${__attr_beg}0;35${__attr_end}"
  994. __color_cyan="${__attr_beg}0;36${__attr_end}"
  995. __color_white="${__attr_beg}0;37${__attr_end}"
  996. __color_light_black="${__attr_beg}1;30${__attr_end}"
  997. __color_light_red="${__attr_beg}1;31${__attr_end}"
  998. __color_light_green="${__attr_beg}1;32${__attr_end}"
  999. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  1000. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1001. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  1002. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1003. __color_light_white="${__attr_beg}1;37${__attr_end}"
  1004. __color_bg_black="${__attr_beg}40${__attr_end}"
  1005. __color_bg_red="${__attr_beg}41${__attr_end}"
  1006. __color_bg_green="${__attr_beg}42${__attr_end}"
  1007. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1008. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1009. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1010. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1011. __color_bg_white="${__attr_beg}47${__attr_end}"
  1012. __attr_underline="${__attr_beg}4${__attr_end}"
  1013. __attr_reverse="${__attr_beg}7${__attr_end}"
  1014. __attr_bold="${__attr_beg}1${__attr_end}"
  1015. fi
  1016. # NOTE: tput is another easy way to set colors and background
  1017. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1018. # color blue.
  1019. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1020. if test "$TERM" != dumb
  1021. then
  1022. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1023. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1024. # color for ::
  1025. if test -z "$_HOSTCOLOR_1"
  1026. then
  1027. # default color used by tmux status line
  1028. _HOSTCOLOR_1=green
  1029. fi
  1030. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1031. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1032. __my_cdef="$__color_default"
  1033. fi
  1034. if $inbash
  1035. then
  1036. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1037. elif $inzsh
  1038. then
  1039. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1040. fi
  1041. __my_ps1_info1(){
  1042. # first line of PS1
  1043. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1044. }
  1045. test -n "$__MY_SCRIPT" && \
  1046. __my_ps1_str_scr="SCR"
  1047. test -n "$SSH_CONNECTION" && \
  1048. __my_ps1_str_ssh="SSH"
  1049. test -n "$__MY_DTACH" && \
  1050. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1051. __my_ps1_info2(){
  1052. # second line of PS1
  1053. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1054. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1055. | sed -e 's/ /|/g'
  1056. }
  1057. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1058. __my_ps1_save_pos="\[\033[s\]"
  1059. __my_ps1_restore_pos="\[\033[u\]"
  1060. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1061. __my_ps1_move_15left="\[\033[15D\]"
  1062. # collapse when command line is too long and try to write over this string
  1063. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1064. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1065. if $inzsh
  1066. then
  1067. PROMPT="\
  1068. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1069. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1070. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1071. elif $inbash
  1072. then
  1073. PS1="\
  1074. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1075. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1076. else
  1077. true
  1078. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1079. fi
  1080. ###################################
  1081. # set header and titles
  1082. __my_set_header_line(){
  1083. # save current position
  1084. printf "\033[s"
  1085. # move to 0,0
  1086. printf "\033[0;0H"
  1087. # clear curent to eol
  1088. printf "\033[K"
  1089. # inverse color
  1090. printf "\033[7m"
  1091. printf "$1"
  1092. # restore color
  1093. printf "\033[0m"
  1094. # restore saved position
  1095. printf "\033[u"
  1096. }
  1097. __my_set_screen_name(){
  1098. # set window name
  1099. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1100. then
  1101. echo -ne "\033k$1\033\\"
  1102. fi
  1103. }
  1104. __my_set_title(){
  1105. case $TERM in
  1106. (rxvt*|xterm*|aterm|screen*)
  1107. test -t 1 &&
  1108. test -z "$EMACS" &&
  1109. echo -n -e "\033]0;$1\007"
  1110. ;;
  1111. esac
  1112. }
  1113. if test -n "$TMUX"
  1114. then
  1115. # running tmux locally
  1116. __terminal_title="\$(basename \${PWD})"
  1117. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1118. then
  1119. # ssh connect from tmux terminal
  1120. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1121. else
  1122. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1123. fi
  1124. if $inzsh
  1125. then
  1126. precmd(){
  1127. laststatus=$?
  1128. eval __my_set_title ${__terminal_title}
  1129. }
  1130. else
  1131. if test -n "$PROMPT_COMMAND" && ! expr "$PROMPT_COMMAND" : '.*; *$' >/dev/null
  1132. then
  1133. PROMPT_COMMAND="${PROMPT_COMMAND};"
  1134. fi
  1135. if test -n "$PROMPT_COMMAND"
  1136. then
  1137. PROMPT_COMMAND="laststatus=\$?;${PROMPT_COMMAND}__my_set_title \"${__terminal_title}\";"
  1138. else
  1139. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";"
  1140. fi
  1141. fi
  1142. laststatus=0